import { IMap } from '../../extensions/global';
export declare type LogLevel = 'error' | 'warn' | 'info' | 'debug' | 'verbose';
interface ILoggerState {
    isEnabled: boolean;
    level: LogLevel;
}
interface ILoggerCreateSection {
    section(name: string): ISectionLogger;
}
export interface ILoggerMethod {
    getTimeTaken(): string;
}
interface ILoggerMethods {
    error(message: string): ILoggerMethod;
    error(message: string, data: IMap): ILoggerMethod;
    error(error: Error): ILoggerMethod;
    error(error: Error, message: string): ILoggerMethod;
    error(error: Error, message: string, data: IMap): ILoggerMethod;
    warn(message: string): ILoggerMethod;
    warn(message: string, data: IMap): ILoggerMethod;
    info(message: string): ILoggerMethod;
    info(message: string, data: IMap): ILoggerMethod;
    debug(message: string): ILoggerMethod;
    debug(message: string, data: IMap): ILoggerMethod;
    verbose(message: string): ILoggerMethod;
    verbose(message: string, data: IMap): ILoggerMethod;
}
export interface ISectionLogger extends ILoggerMethods, Readonly<ILoggerState>, ILoggerCreateSection {
    end(): void;
}
export interface ILogger extends ILoggerMethods, ILoggerState, ILoggerCreateSection {
    close(): Promise<void>;
}
export declare namespace ILogger {
    function ensureImplemented<T extends ILogger | ISectionLogger>(logger: T): T;
}
export {};
